/* engine.c generated by valac 0.38.3, the Vala compiler
 * generated from engine.vala, do not modify */

/* 
 * Copyright (C) 2011-2014 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2014 Red Hat, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <ibus.h>
#include <libkkc/libkkc.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libutil.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <stdio.h>
#include <gdk/gdk.h>


#define TYPE_KKC_ENGINE (kkc_engine_get_type ())
#define KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KKC_ENGINE, KkcEngine))
#define KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KKC_ENGINE, KkcEngineClass))
#define IS_KKC_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KKC_ENGINE))
#define IS_KKC_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KKC_ENGINE))
#define KKC_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KKC_ENGINE, KkcEngineClass))

typedef struct _KkcEngine KkcEngine;
typedef struct _KkcEngineClass KkcEngineClass;
typedef struct _KkcEnginePrivate KkcEnginePrivate;
enum  {
	KKC_ENGINE_0_PROPERTY,
	KKC_ENGINE_NUM_PROPERTIES
};
static GParamSpec* kkc_engine_properties[KKC_ENGINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _KkcEngine {
	IBusEngine parent_instance;
	KkcEnginePrivate * priv;
};

struct _KkcEngineClass {
	IBusEngineClass parent_class;
};

struct _KkcEnginePrivate {
	KkcContext* context;
	IBusLookupTable* lookup_table;
	gboolean lookup_table_visible;
	gboolean use_custom_keymap;
	gboolean show_annotation;
	IBusKeymap* keymap;
	IBusProperty* input_mode_prop;
	IBusPropList* prop_list;
	gboolean properties_registered;
	GeeMap* input_mode_props;
	GeeMap* input_mode_symbols;
	GeeMap* name_input_modes;
	GtkClipboard* clipboard;
	guint save_dictionaries_timeout_id;
};


static gpointer kkc_engine_parent_class = NULL;
static Preferences* kkc_engine_preferences;
static Preferences* kkc_engine_preferences = NULL;
static GeeArrayList* kkc_engine_dictionaries;
static GeeArrayList* kkc_engine_dictionaries = NULL;
static KkcLanguageModel* kkc_engine_language_model;
static KkcLanguageModel* kkc_engine_language_model = NULL;
static gboolean kkc_engine_ibus;
static gboolean kkc_engine_ibus = FALSE;

GType kkc_engine_get_type (void) G_GNUC_CONST;
#define KKC_ENGINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_KKC_ENGINE, KkcEnginePrivate))
static void kkc_engine_set_selection_text (GtkClipboard* clipboard, const gchar* text, KkcEngine* self);
static void kkc_engine_populate_lookup_table (KkcEngine* self);
static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self);
static void kkc_engine_update_preedit (KkcEngine* self);
static void kkc_engine_update_candidates (KkcEngine* self);
static void kkc_engine_update_input_mode (KkcEngine* self);
static void kkc_engine_reload_dictionaries (void);
static void kkc_engine_apply_preferences (KkcEngine* self);
static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self, KkcInputMode mode, const gchar* name, const gchar* label, const gchar* symbol);
static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self, guint keyval, guint keycode, guint state);
static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle);
static gboolean kkc_engine_real_process_key_event (IBusEngine* base, guint keyval, guint keycode, guint state);
static void kkc_engine_real_enable (IBusEngine* base);
static gboolean __lambda4_ (KkcEngine* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static void kkc_engine_real_disable (IBusEngine* base);
static void kkc_engine_real_reset (IBusEngine* base);
static void kkc_engine_real_focus_in (IBusEngine* base);
static void kkc_engine_real_focus_out (IBusEngine* base);
static void kkc_engine_real_property_activate (IBusEngine* base, const gchar* prop_name, guint prop_state);
static void kkc_engine_real_candidate_clicked (IBusEngine* base, guint index, guint button, guint state);
static void kkc_engine_real_cursor_up (IBusEngine* base);
static void kkc_engine_real_cursor_down (IBusEngine* base);
static void kkc_engine_real_page_up (IBusEngine* base);
static void kkc_engine_real_page_down (IBusEngine* base);
static void kkc_engine_real_set_content_type (IBusEngine* base, guint purpose, guint hints);
gint kkc_engine_main (gchar** args, int args_length1);
static void __lambda5_ (void);
static void ___lambda5__ibus_bus_disconnected (IBusBus* _sender, gpointer self);
static void __lambda6_ (const gchar* name, GVariant* value);
static void ___lambda6__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self);
KkcEngine* kkc_engine_new (void);
KkcEngine* kkc_engine_construct (GType object_type);
static GObject * kkc_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _kkc_engine___lambda7_ (KkcEngine* self, const gchar* name, GVariant* value);
static void __kkc_engine___lambda7__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self);
static void _kkc_engine___lambda8_ (KkcEngine* self);
static void __kkc_engine___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda9_ (KkcEngine* self, GObject* s, GParamSpec* p);
static void __kkc_engine___lambda9__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda10_ (KkcEngine* self);
static void __kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender, gpointer self);
static void _kkc_engine___lambda11_ (KkcEngine* self);
static void __kkc_engine___lambda11__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void _kkc_engine___lambda12_ (KkcEngine* self);
static void __kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender, KkcCandidate* candidate, gpointer self);
static void _kkc_engine___lambda13_ (KkcEngine* self, KkcContext* e);
static void __kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender, gpointer self);
static void kkc_engine_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* KKC_ENGINE_LOOKUP_TABLE_LABELS[16] = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "a", "b", "c", "d", "e", "f"};
static const GOptionEntry KKC_ENGINE_options[2] = {{"ibus", 'i', 0, G_OPTION_ARG_NONE, &kkc_engine_ibus, N_ ("Component is executed by IBus"), NULL}, {NULL}};

static void kkc_engine_set_selection_text (GtkClipboard* clipboard, const gchar* text, KkcEngine* self) {
	KkcContext* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (clipboard != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = text;
	kkc_context_set_selection_text (_tmp0_, _tmp1_);
}


static void kkc_engine_populate_lookup_table (KkcEngine* self) {
	IBusLookupTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->lookup_table;
	ibus_lookup_table_clear (_tmp0_);
	{
		gint i = 0;
		KkcContext* _tmp1_;
		KkcCandidateList* _tmp2_;
		KkcCandidateList* _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		_tmp1_ = self->priv->context;
		_tmp2_ = kkc_context_get_candidates (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = kkc_candidate_list_get_page_start (_tmp3_);
		_tmp5_ = _tmp4_;
		i = (gint) _tmp5_;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				gint _tmp8_;
				KkcContext* _tmp9_;
				KkcCandidateList* _tmp10_;
				KkcCandidateList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				IBusText* text = NULL;
				KkcContext* _tmp14_;
				KkcCandidateList* _tmp15_;
				KkcCandidateList* _tmp16_;
				gint _tmp17_;
				KkcCandidate* _tmp18_;
				KkcCandidate* _tmp19_;
				const gchar* _tmp20_;
				const gchar* _tmp21_;
				IBusText* _tmp22_;
				IBusText* _tmp23_;
				IBusLookupTable* _tmp24_;
				IBusText* _tmp25_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp6_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = self->priv->context;
				_tmp10_ = kkc_context_get_candidates (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = kkc_candidate_list_get_size (_tmp11_);
				_tmp13_ = _tmp12_;
				if (!(_tmp8_ < _tmp13_)) {
					break;
				}
				_tmp14_ = self->priv->context;
				_tmp15_ = kkc_context_get_candidates (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = i;
				_tmp18_ = kkc_candidate_list_get (_tmp16_, _tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = kkc_candidate_get_output (_tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = ibus_text_new_from_string (_tmp21_);
				g_object_ref_sink (_tmp22_);
				_tmp23_ = _tmp22_;
				_g_object_unref0 (_tmp19_);
				text = _tmp23_;
				_tmp24_ = self->priv->lookup_table;
				_tmp25_ = text;
				ibus_lookup_table_append_candidate (_tmp24_, _tmp25_);
				_g_object_unref0 (text);
			}
		}
	}
}


static void kkc_engine_set_lookup_table_cursor_pos (KkcEngine* self) {
	IBusText* empty_text = NULL;
	IBusText* _tmp0_;
	gint cursor_pos = 0;
	KkcContext* _tmp1_;
	KkcCandidateList* _tmp2_;
	KkcCandidateList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	KkcContext* _tmp6_;
	KkcCandidateList* _tmp7_;
	KkcCandidateList* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = ibus_text_new_from_static_string ("");
	g_object_ref_sink (_tmp0_);
	empty_text = _tmp0_;
	_tmp1_ = self->priv->context;
	_tmp2_ = kkc_context_get_candidates (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = kkc_candidate_list_get_cursor_pos (_tmp3_);
	_tmp5_ = _tmp4_;
	cursor_pos = _tmp5_;
	_tmp6_ = self->priv->context;
	_tmp7_ = kkc_context_get_candidates (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = kkc_candidate_list_get_page_visible (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		IBusLookupTable* _tmp11_;
		gint _tmp12_;
		KkcContext* _tmp13_;
		KkcCandidateList* _tmp14_;
		KkcCandidateList* _tmp15_;
		guint _tmp16_;
		guint _tmp17_;
		IBusLookupTable* _tmp18_;
		KkcCandidate* candidate = NULL;
		KkcContext* _tmp19_;
		KkcCandidateList* _tmp20_;
		KkcCandidateList* _tmp21_;
		KkcCandidate* _tmp22_;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_;
		_tmp11_ = self->priv->lookup_table;
		_tmp12_ = cursor_pos;
		_tmp13_ = self->priv->context;
		_tmp14_ = kkc_context_get_candidates (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = kkc_candidate_list_get_page_start (_tmp15_);
		_tmp17_ = _tmp16_;
		ibus_lookup_table_set_cursor_pos (_tmp11_, _tmp12_ - _tmp17_);
		_tmp18_ = self->priv->lookup_table;
		ibus_engine_update_lookup_table_fast ((IBusEngine*) self, _tmp18_, TRUE);
		_tmp19_ = self->priv->context;
		_tmp20_ = kkc_context_get_candidates (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = kkc_candidate_list_get (_tmp21_, -1);
		candidate = _tmp22_;
		_tmp25_ = self->priv->show_annotation;
		if (_tmp25_) {
			KkcCandidate* _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			_tmp26_ = candidate;
			_tmp27_ = kkc_candidate_get_annotation (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp24_ = _tmp28_ != NULL;
		} else {
			_tmp24_ = FALSE;
		}
		if (_tmp24_) {
			KkcCandidate* _tmp29_;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			_tmp29_ = candidate;
			_tmp30_ = kkc_candidate_get_annotation (_tmp29_);
			_tmp31_ = _tmp30_;
			_tmp23_ = g_strcmp0 (_tmp31_, "?") != 0;
		} else {
			_tmp23_ = FALSE;
		}
		if (_tmp23_) {
			IBusText* text = NULL;
			KkcCandidate* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			IBusText* _tmp35_;
			IBusText* _tmp36_;
			_tmp32_ = candidate;
			_tmp33_ = kkc_candidate_get_annotation (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = ibus_text_new_from_string (_tmp34_);
			g_object_ref_sink (_tmp35_);
			text = _tmp35_;
			_tmp36_ = text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp36_, TRUE);
			_g_object_unref0 (text);
		} else {
			IBusText* _tmp37_;
			_tmp37_ = empty_text;
			ibus_engine_update_auxiliary_text ((IBusEngine*) self, _tmp37_, FALSE);
		}
		self->priv->lookup_table_visible = TRUE;
		_g_object_unref0 (candidate);
	} else {
		gboolean _tmp38_;
		_tmp38_ = self->priv->lookup_table_visible;
		if (_tmp38_) {
			ibus_engine_hide_lookup_table ((IBusEngine*) self);
			ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
			self->priv->lookup_table_visible = FALSE;
		}
	}
	_g_object_unref0 (empty_text);
}


static void kkc_engine_update_preedit (KkcEngine* self) {
	IBusText* text = NULL;
	guint cursor_pos = 0U;
	KkcContext* _tmp0_;
	KkcSegmentList* _tmp1_;
	KkcSegmentList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	IBusText* _tmp90_;
	guint _tmp91_;
	KkcContext* _tmp95_;
	gboolean _tmp96_;
	IBusText* _tmp102_;
	guint _tmp103_;
	IBusText* _tmp104_;
	guint _tmp105_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_segments (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = kkc_segment_list_get_cursor_pos (_tmp2_);
	_tmp4_ = _tmp3_;
	if (_tmp4_ >= 0) {
		KkcContext* _tmp5_;
		KkcSegmentList* _tmp6_;
		KkcSegmentList* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		IBusText* _tmp10_;
		gint index = 0;
		gint offset = 0;
		IBusText* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		KkcContext* _tmp32_;
		KkcSegmentList* _tmp33_;
		KkcSegmentList* _tmp34_;
		gint _tmp35_;
		KkcSegment* _tmp36_;
		KkcSegment* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
		gint _tmp40_;
		IBusText* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		KkcContext* _tmp44_;
		KkcSegmentList* _tmp45_;
		KkcSegmentList* _tmp46_;
		gint _tmp47_;
		KkcSegment* _tmp48_;
		KkcSegment* _tmp49_;
		const gchar* _tmp50_;
		const gchar* _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
		_tmp5_ = self->priv->context;
		_tmp6_ = kkc_context_get_segments (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = kkc_segment_list_get_output (_tmp7_);
		_tmp9_ = _tmp8_;
		_tmp10_ = ibus_text_new_from_string (_tmp9_);
		g_object_ref_sink (_tmp10_);
		_g_object_unref0 (text);
		text = _tmp10_;
		_g_free0 (_tmp9_);
		index = 0;
		offset = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gint _tmp13_;
				KkcContext* _tmp14_;
				KkcSegmentList* _tmp15_;
				KkcSegmentList* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				KkcContext* _tmp20_;
				KkcSegmentList* _tmp21_;
				KkcSegmentList* _tmp22_;
				gint _tmp23_;
				KkcSegment* _tmp24_;
				KkcSegment* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = index;
					index = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				_tmp13_ = index;
				_tmp14_ = self->priv->context;
				_tmp15_ = kkc_context_get_segments (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = kkc_segment_list_get_cursor_pos (_tmp16_);
				_tmp18_ = _tmp17_;
				if (!(_tmp13_ < _tmp18_)) {
					break;
				}
				_tmp19_ = offset;
				_tmp20_ = self->priv->context;
				_tmp21_ = kkc_context_get_segments (_tmp20_);
				_tmp22_ = _tmp21_;
				_tmp23_ = index;
				_tmp24_ = kkc_segment_list_get (_tmp22_, _tmp23_);
				_tmp25_ = _tmp24_;
				_tmp26_ = kkc_segment_get_output (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = g_utf8_strlen (_tmp27_, (gssize) -1);
				offset = _tmp19_ + _tmp28_;
				_g_object_unref0 (_tmp25_);
			}
		}
		_tmp29_ = text;
		_tmp30_ = offset;
		_tmp31_ = offset;
		_tmp32_ = self->priv->context;
		_tmp33_ = kkc_context_get_segments (_tmp32_);
		_tmp34_ = _tmp33_;
		_tmp35_ = index;
		_tmp36_ = kkc_segment_list_get (_tmp34_, _tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = kkc_segment_get_output (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = g_utf8_strlen (_tmp39_, (gssize) -1);
		ibus_text_append_attribute (_tmp29_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00c8c8f0, (guint) _tmp30_, _tmp31_ + _tmp40_);
		_g_object_unref0 (_tmp37_);
		_tmp41_ = text;
		_tmp42_ = offset;
		_tmp43_ = offset;
		_tmp44_ = self->priv->context;
		_tmp45_ = kkc_context_get_segments (_tmp44_);
		_tmp46_ = _tmp45_;
		_tmp47_ = index;
		_tmp48_ = kkc_segment_list_get (_tmp46_, _tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = kkc_segment_get_output (_tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = g_utf8_strlen (_tmp51_, (gssize) -1);
		ibus_text_append_attribute (_tmp41_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0x00000000, (guint) _tmp42_, _tmp43_ + _tmp52_);
		_g_object_unref0 (_tmp49_);
		_tmp53_ = offset;
		cursor_pos = (guint) _tmp53_;
	} else {
		KkcContext* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		IBusText* _tmp58_;
		gboolean _tmp59_ = FALSE;
		IBusText* _tmp60_;
		guint _tmp61_;
		_tmp54_ = self->priv->context;
		_tmp55_ = kkc_context_get_input (_tmp54_);
		_tmp56_ = _tmp55_;
		_tmp57_ = _tmp56_;
		_tmp58_ = ibus_text_new_from_string (_tmp57_);
		g_object_ref_sink (_tmp58_);
		_g_object_unref0 (text);
		text = _tmp58_;
		_g_free0 (_tmp57_);
		_tmp60_ = text;
		_tmp61_ = ibus_text_get_length (_tmp60_);
		if (_tmp61_ > ((guint) 0)) {
			KkcContext* _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			_tmp62_ = self->priv->context;
			_tmp63_ = kkc_context_get_input_cursor_pos (_tmp62_);
			_tmp64_ = _tmp63_;
			_tmp59_ = _tmp64_ >= 0;
		} else {
			_tmp59_ = FALSE;
		}
		if (_tmp59_) {
			IBusText* _tmp65_;
			KkcContext* _tmp66_;
			gint _tmp67_;
			gint _tmp68_;
			KkcContext* _tmp69_;
			gint _tmp70_;
			gint _tmp71_;
			KkcContext* _tmp72_;
			guint _tmp73_;
			guint _tmp74_;
			IBusText* _tmp75_;
			KkcContext* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
			KkcContext* _tmp79_;
			gint _tmp80_;
			gint _tmp81_;
			KkcContext* _tmp82_;
			guint _tmp83_;
			guint _tmp84_;
			KkcContext* _tmp85_;
			gint _tmp86_;
			gint _tmp87_;
			_tmp65_ = text;
			_tmp66_ = self->priv->context;
			_tmp67_ = kkc_context_get_input_cursor_pos (_tmp66_);
			_tmp68_ = _tmp67_;
			_tmp69_ = self->priv->context;
			_tmp70_ = kkc_context_get_input_cursor_pos (_tmp69_);
			_tmp71_ = _tmp70_;
			_tmp72_ = self->priv->context;
			_tmp73_ = kkc_context_get_input_cursor_width (_tmp72_);
			_tmp74_ = _tmp73_;
			ibus_text_append_attribute (_tmp65_, (guint) IBUS_ATTR_TYPE_BACKGROUND, (guint) 0x00000000, (guint) _tmp68_, _tmp71_ + ((gint) _tmp74_));
			_tmp75_ = text;
			_tmp76_ = self->priv->context;
			_tmp77_ = kkc_context_get_input_cursor_pos (_tmp76_);
			_tmp78_ = _tmp77_;
			_tmp79_ = self->priv->context;
			_tmp80_ = kkc_context_get_input_cursor_pos (_tmp79_);
			_tmp81_ = _tmp80_;
			_tmp82_ = self->priv->context;
			_tmp83_ = kkc_context_get_input_cursor_width (_tmp82_);
			_tmp84_ = _tmp83_;
			ibus_text_append_attribute (_tmp75_, (guint) IBUS_ATTR_TYPE_FOREGROUND, (guint) 0xffffffffLL, (guint) _tmp78_, _tmp81_ + ((gint) _tmp84_));
			_tmp85_ = self->priv->context;
			_tmp86_ = kkc_context_get_input_cursor_pos (_tmp85_);
			_tmp87_ = _tmp86_;
			cursor_pos = (guint) _tmp87_;
		} else {
			IBusText* _tmp88_;
			guint _tmp89_;
			_tmp88_ = text;
			_tmp89_ = ibus_text_get_length (_tmp88_);
			cursor_pos = _tmp89_;
		}
	}
	_tmp90_ = text;
	_tmp91_ = ibus_text_get_length (_tmp90_);
	if (_tmp91_ > ((guint) 0)) {
		IBusText* _tmp92_;
		IBusText* _tmp93_;
		guint _tmp94_;
		_tmp92_ = text;
		_tmp93_ = text;
		_tmp94_ = ibus_text_get_length (_tmp93_);
		ibus_text_append_attribute (_tmp92_, (guint) IBUS_ATTR_TYPE_UNDERLINE, (guint) IBUS_ATTR_UNDERLINE_SINGLE, (guint) 0, (gint) _tmp94_);
	}
	_tmp95_ = self->priv->context;
	_tmp96_ = kkc_context_has_output (_tmp95_);
	if (_tmp96_) {
		gchar* output = NULL;
		KkcContext* _tmp97_;
		gchar* _tmp98_;
		IBusText* ctext = NULL;
		const gchar* _tmp99_;
		IBusText* _tmp100_;
		IBusText* _tmp101_;
		_tmp97_ = self->priv->context;
		_tmp98_ = kkc_context_poll_output (_tmp97_);
		output = _tmp98_;
		_tmp99_ = output;
		_tmp100_ = ibus_text_new_from_string (_tmp99_);
		g_object_ref_sink (_tmp100_);
		ctext = _tmp100_;
		_tmp101_ = ctext;
		ibus_engine_commit_text ((IBusEngine*) self, _tmp101_);
		_g_object_unref0 (ctext);
		_g_free0 (output);
	}
	_tmp102_ = text;
	_tmp103_ = cursor_pos;
	_tmp104_ = text;
	_tmp105_ = ibus_text_get_length (_tmp104_);
	ibus_engine_update_preedit_text ((IBusEngine*) self, _tmp102_, _tmp103_, _tmp105_ > ((guint) 0));
	_g_object_unref0 (text);
}


static void kkc_engine_update_candidates (KkcEngine* self) {
	g_return_if_fail (self != NULL);
	kkc_engine_populate_lookup_table (self);
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void kkc_engine_update_input_mode (KkcEngine* self) {
	gboolean changed = FALSE;
	GeeMapIterator* iter = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	IBusText* symbol = NULL;
	GeeMap* _tmp22_;
	KkcContext* _tmp23_;
	KkcInputMode _tmp24_;
	KkcInputMode _tmp25_;
	gpointer _tmp26_;
	gchar* _tmp27_;
	IBusText* _tmp28_;
	IBusText* _tmp29_;
	IBusText* label = NULL;
	IBusText* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	IBusText* _tmp34_;
	IBusText* _tmp35_;
	IBusProperty* _tmp36_;
	IBusText* _tmp37_;
	IBusText* _tmp38_;
	IBusProperty* _tmp41_;
	IBusText* _tmp42_;
	IBusText* _tmp43_;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->input_mode_props;
	_tmp1_ = gee_map_map_iterator (_tmp0_);
	iter = _tmp1_;
	while (TRUE) {
		GeeMapIterator* _tmp2_;
		gboolean _tmp3_;
		KkcInputMode input_mode = 0;
		GeeMapIterator* _tmp4_;
		gpointer _tmp5_;
		IBusProperty* prop = NULL;
		GeeMapIterator* _tmp6_;
		gpointer _tmp7_;
		KkcInputMode _tmp8_;
		KkcContext* _tmp9_;
		KkcInputMode _tmp10_;
		KkcInputMode _tmp11_;
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_;
		_tmp2_ = iter;
		_tmp3_ = gee_map_iterator_next (_tmp2_);
		if (!_tmp3_) {
			break;
		}
		_tmp4_ = iter;
		_tmp5_ = gee_map_iterator_get_key (_tmp4_);
		input_mode = (KkcInputMode) ((gintptr) _tmp5_);
		_tmp6_ = iter;
		_tmp7_ = gee_map_iterator_get_value (_tmp6_);
		prop = (IBusProperty*) _tmp7_;
		changed = FALSE;
		_tmp8_ = input_mode;
		_tmp9_ = self->priv->context;
		_tmp10_ = kkc_context_get_input_mode (_tmp9_);
		_tmp11_ = _tmp10_;
		if (_tmp8_ == _tmp11_) {
			IBusProperty* _tmp12_;
			IBusPropState _tmp13_;
			_tmp12_ = prop;
			_tmp13_ = ibus_property_get_state (_tmp12_);
			if (_tmp13_ == PROP_STATE_UNCHECKED) {
				IBusProperty* _tmp14_;
				_tmp14_ = prop;
				ibus_property_set_state (_tmp14_, PROP_STATE_CHECKED);
				changed = TRUE;
			}
		} else {
			IBusProperty* _tmp15_;
			IBusPropState _tmp16_;
			_tmp15_ = prop;
			_tmp16_ = ibus_property_get_state (_tmp15_);
			if (_tmp16_ == PROP_STATE_CHECKED) {
				IBusProperty* _tmp17_;
				_tmp17_ = prop;
				ibus_property_set_state (_tmp17_, PROP_STATE_UNCHECKED);
				changed = TRUE;
			}
		}
		_tmp19_ = changed;
		if (_tmp19_) {
			gboolean _tmp20_;
			_tmp20_ = self->priv->properties_registered;
			_tmp18_ = _tmp20_;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			IBusProperty* _tmp21_;
			_tmp21_ = prop;
			ibus_engine_update_property ((IBusEngine*) self, _tmp21_);
		}
		_g_object_unref0 (prop);
	}
	changed = FALSE;
	_tmp22_ = self->priv->input_mode_symbols;
	_tmp23_ = self->priv->context;
	_tmp24_ = kkc_context_get_input_mode (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = gee_map_get (_tmp22_, (gpointer) ((gintptr) _tmp25_));
	_tmp27_ = (gchar*) _tmp26_;
	_tmp28_ = ibus_text_new_from_string (_tmp27_);
	g_object_ref_sink (_tmp28_);
	_tmp29_ = _tmp28_;
	_g_free0 (_tmp27_);
	symbol = _tmp29_;
	_tmp30_ = symbol;
	_tmp31_ = _tmp30_->text;
	_tmp32_ = g_strdup_printf (_ ("Input Mode (%s)"), _tmp31_);
	_tmp33_ = _tmp32_;
	_tmp34_ = ibus_text_new_from_string (_tmp33_);
	g_object_ref_sink (_tmp34_);
	_tmp35_ = _tmp34_;
	_g_free0 (_tmp33_);
	label = _tmp35_;
	_tmp36_ = self->priv->input_mode_prop;
	_tmp37_ = ibus_property_get_symbol (_tmp36_);
	_tmp38_ = symbol;
	if (_tmp37_ != _tmp38_) {
		IBusProperty* _tmp39_;
		IBusText* _tmp40_;
		_tmp39_ = self->priv->input_mode_prop;
		_tmp40_ = symbol;
		ibus_property_set_symbol (_tmp39_, _tmp40_);
		changed = TRUE;
	}
	_tmp41_ = self->priv->input_mode_prop;
	_tmp42_ = ibus_property_get_label (_tmp41_);
	_tmp43_ = label;
	if (_tmp42_ != _tmp43_) {
		IBusProperty* _tmp44_;
		IBusText* _tmp45_;
		_tmp44_ = self->priv->input_mode_prop;
		_tmp45_ = label;
		ibus_property_set_label (_tmp44_, _tmp45_);
		changed = TRUE;
	}
	_tmp47_ = changed;
	if (_tmp47_) {
		gboolean _tmp48_;
		_tmp48_ = self->priv->properties_registered;
		_tmp46_ = _tmp48_;
	} else {
		_tmp46_ = FALSE;
	}
	if (_tmp46_) {
		IBusProperty* _tmp49_;
		_tmp49_ = self->priv->input_mode_prop;
		ibus_engine_update_property ((IBusEngine*) self, _tmp49_);
	}
	_g_object_unref0 (label);
	_g_object_unref0 (symbol);
	_g_object_unref0 (iter);
}


static void kkc_engine_reload_dictionaries (void) {
	GeeArrayList* _tmp0_;
	GVariant* variant = NULL;
	Preferences* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	Preferences* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	gchar** strv = NULL;
	GVariant* _tmp16_;
	size_t _tmp17_;
	gchar** _tmp18_;
	gint strv_length1;
	gint _strv_size_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	GError * _inner_error_ = NULL;
	_tmp0_ = kkc_engine_dictionaries;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = kkc_engine_preferences;
	_tmp2_ = preferences_get (_tmp1_, "user_dictionary");
	_g_variant_unref0 (variant);
	variant = _tmp2_;
	_tmp3_ = variant;
	if (_tmp3_ != NULL) {
		{
			KkcUserDictionary* _tmp4_ = NULL;
			GVariant* _tmp5_;
			const gchar* _tmp6_;
			KkcUserDictionary* _tmp7_;
			GeeArrayList* _tmp8_;
			_tmp5_ = variant;
			_tmp6_ = g_variant_get_string (_tmp5_, NULL);
			_tmp7_ = kkc_user_dictionary_new (_tmp6_, &_inner_error_);
			_tmp4_ = _tmp7_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp8_ = kkc_engine_dictionaries;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, (KkcDictionary*) _tmp4_);
			_g_object_unref0 (_tmp4_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			GError* _tmp11_;
			const gchar* _tmp12_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp9_ = variant;
			_tmp10_ = g_variant_get_string (_tmp9_, NULL);
			_tmp11_ = e;
			_tmp12_ = _tmp11_->message;
			g_warning ("engine.vala:339: can't load user dictionary %s: %s", _tmp10_, _tmp12_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_variant_unref0 (variant);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp13_ = kkc_engine_preferences;
	_tmp14_ = preferences_get (_tmp13_, "system_dictionaries");
	_g_variant_unref0 (variant);
	variant = _tmp14_;
	_tmp15_ = variant;
	_vala_assert (_tmp15_ != NULL, "variant != null");
	_tmp16_ = variant;
	_tmp18_ = g_variant_dup_strv (_tmp16_, &_tmp17_);
	strv = _tmp18_;
	strv_length1 = _tmp17_;
	_strv_size_ = strv_length1;
	_tmp19_ = strv;
	_tmp19__length1 = strv_length1;
	{
		gchar** id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
		id_collection = _tmp19_;
		id_collection_length1 = _tmp19__length1;
		for (id_it = 0; id_it < _tmp19__length1; id_it = id_it + 1) {
			gchar* _tmp20_;
			gchar* id = NULL;
			_tmp20_ = g_strdup (id_collection[id_it]);
			id = _tmp20_;
			{
				DictionaryMetadata* metadata = NULL;
				Preferences* _tmp21_;
				const gchar* _tmp22_;
				DictionaryMetadata* _tmp23_;
				_tmp21_ = kkc_engine_preferences;
				_tmp22_ = id;
				_tmp23_ = preferences_get_dictionary_metadata (_tmp21_, _tmp22_);
				metadata = _tmp23_;
				{
					KkcSystemSegmentDictionary* _tmp24_ = NULL;
					DictionaryMetadata* _tmp25_;
					const gchar* _tmp26_;
					const gchar* _tmp27_;
					DictionaryMetadata* _tmp28_;
					const gchar* _tmp29_;
					const gchar* _tmp30_;
					KkcSystemSegmentDictionary* _tmp31_;
					GeeArrayList* _tmp32_;
					_tmp25_ = metadata;
					_tmp26_ = dictionary_metadata_get_filename (_tmp25_);
					_tmp27_ = _tmp26_;
					_tmp28_ = metadata;
					_tmp29_ = dictionary_metadata_get_encoding (_tmp28_);
					_tmp30_ = _tmp29_;
					_tmp31_ = kkc_system_segment_dictionary_new (_tmp27_, _tmp30_, &_inner_error_);
					_tmp24_ = _tmp31_;
					if (G_UNLIKELY (_inner_error_ != NULL)) {
						goto __catch1_g_error;
					}
					_tmp32_ = kkc_engine_dictionaries;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, (KkcDictionary*) _tmp24_);
					_g_object_unref0 (_tmp24_);
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					DictionaryMetadata* _tmp33_;
					const gchar* _tmp34_;
					const gchar* _tmp35_;
					GError* _tmp36_;
					const gchar* _tmp37_;
					e = _inner_error_;
					_inner_error_ = NULL;
					_tmp33_ = metadata;
					_tmp34_ = dictionary_metadata_get_filename (_tmp33_);
					_tmp35_ = _tmp34_;
					_tmp36_ = e;
					_tmp37_ = _tmp36_->message;
					g_warning ("engine.vala:355: can't load system dictionary %s: %s", _tmp35_, _tmp37_);
					_g_error_free0 (e);
				}
				__finally1:
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_object_unref0 (metadata);
					_g_free0 (id);
					strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
					_g_variant_unref0 (variant);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_g_object_unref0 (metadata);
				_g_free0 (id);
			}
		}
	}
	strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
	_g_variant_unref0 (variant);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void kkc_engine_apply_preferences (KkcEngine* self) {
	GVariant* variant = NULL;
	Preferences* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	KkcContext* _tmp3_;
	GVariant* _tmp4_;
	gint32 _tmp5_;
	Preferences* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	KkcContext* _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp11_;
	Preferences* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	KkcContext* _tmp15_;
	KkcCandidateList* _tmp16_;
	KkcCandidateList* _tmp17_;
	GVariant* _tmp18_;
	gint32 _tmp19_;
	IBusLookupTable* _tmp20_;
	GVariant* _tmp21_;
	gint32 _tmp22_;
	Preferences* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	KkcContext* _tmp26_;
	KkcCandidateList* _tmp27_;
	KkcCandidateList* _tmp28_;
	GVariant* _tmp29_;
	gint32 _tmp30_;
	Preferences* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	KkcContext* _tmp34_;
	GVariant* _tmp35_;
	gint32 _tmp36_;
	Preferences* _tmp37_;
	GVariant* _tmp38_;
	GVariant* _tmp39_;
	GVariant* _tmp40_;
	gboolean _tmp41_;
	Preferences* _tmp42_;
	GVariant* _tmp43_;
	GVariant* _tmp44_;
	KkcRuleMetadata* parent_metadata = NULL;
	GVariant* _tmp45_;
	const gchar* _tmp46_;
	KkcRuleMetadata* _tmp47_;
	gchar* base_dir = NULL;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	Preferences* _tmp57_;
	GVariant* _tmp58_;
	GVariant* _tmp59_;
	GVariant* _tmp60_;
	gboolean _tmp61_;
	Preferences* _tmp62_;
	GVariant* _tmp63_;
	GVariant* _tmp64_;
	GVariant* _tmp65_;
	const gchar* _tmp66_;
	IBusKeymap* _tmp67_;
	IBusKeymap* _tmp68_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = kkc_engine_preferences;
	_tmp1_ = preferences_get (_tmp0_, "punctuation_style");
	_g_variant_unref0 (variant);
	variant = _tmp1_;
	_tmp2_ = variant;
	_vala_assert (_tmp2_ != NULL, "variant != null");
	_tmp3_ = self->priv->context;
	_tmp4_ = variant;
	_tmp5_ = g_variant_get_int32 (_tmp4_);
	kkc_context_set_punctuation_style (_tmp3_, (KkcPunctuationStyle) _tmp5_);
	_tmp6_ = kkc_engine_preferences;
	_tmp7_ = preferences_get (_tmp6_, "auto_correct");
	_g_variant_unref0 (variant);
	variant = _tmp7_;
	_tmp8_ = variant;
	_vala_assert (_tmp8_ != NULL, "variant != null");
	_tmp9_ = self->priv->context;
	_tmp10_ = variant;
	_tmp11_ = g_variant_get_boolean (_tmp10_);
	kkc_context_set_auto_correct (_tmp9_, _tmp11_);
	_tmp12_ = kkc_engine_preferences;
	_tmp13_ = preferences_get (_tmp12_, "page_size");
	_g_variant_unref0 (variant);
	variant = _tmp13_;
	_tmp14_ = variant;
	_vala_assert (_tmp14_ != NULL, "variant != null");
	_tmp15_ = self->priv->context;
	_tmp16_ = kkc_context_get_candidates (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = variant;
	_tmp19_ = g_variant_get_int32 (_tmp18_);
	kkc_candidate_list_set_page_size (_tmp17_, (guint) _tmp19_);
	_tmp20_ = self->priv->lookup_table;
	_tmp21_ = variant;
	_tmp22_ = g_variant_get_int32 (_tmp21_);
	ibus_lookup_table_set_page_size (_tmp20_, (guint) _tmp22_);
	_tmp23_ = kkc_engine_preferences;
	_tmp24_ = preferences_get (_tmp23_, "pagination_start");
	_g_variant_unref0 (variant);
	variant = _tmp24_;
	_tmp25_ = variant;
	_vala_assert (_tmp25_ != NULL, "variant != null");
	_tmp26_ = self->priv->context;
	_tmp27_ = kkc_context_get_candidates (_tmp26_);
	_tmp28_ = _tmp27_;
	_tmp29_ = variant;
	_tmp30_ = g_variant_get_int32 (_tmp29_);
	kkc_candidate_list_set_page_start (_tmp28_, (guint) _tmp30_);
	_tmp31_ = kkc_engine_preferences;
	_tmp32_ = preferences_get (_tmp31_, "initial_input_mode");
	_g_variant_unref0 (variant);
	variant = _tmp32_;
	_tmp33_ = variant;
	_vala_assert (_tmp33_ != NULL, "variant != null");
	_tmp34_ = self->priv->context;
	_tmp35_ = variant;
	_tmp36_ = g_variant_get_int32 (_tmp35_);
	kkc_context_set_input_mode (_tmp34_, (KkcInputMode) _tmp36_);
	_tmp37_ = kkc_engine_preferences;
	_tmp38_ = preferences_get (_tmp37_, "show_annotation");
	_g_variant_unref0 (variant);
	variant = _tmp38_;
	_tmp39_ = variant;
	_vala_assert (_tmp39_ != NULL, "variant != null");
	_tmp40_ = variant;
	_tmp41_ = g_variant_get_boolean (_tmp40_);
	self->priv->show_annotation = _tmp41_;
	_tmp42_ = kkc_engine_preferences;
	_tmp43_ = preferences_get (_tmp42_, "typing_rule");
	_g_variant_unref0 (variant);
	variant = _tmp43_;
	_tmp44_ = variant;
	_vala_assert (_tmp44_ != NULL, "variant != null");
	_tmp45_ = variant;
	_tmp46_ = g_variant_get_string (_tmp45_, NULL);
	_tmp47_ = kkc_rule_metadata_find (_tmp46_);
	parent_metadata = _tmp47_;
	_vala_assert (parent_metadata != NULL, "parent_metadata != null");
	_tmp48_ = g_get_user_config_dir ();
	_tmp49_ = g_build_filename (_tmp48_, "ibus-kkc", "rules", NULL);
	base_dir = _tmp49_;
	{
		KkcUserRule* _tmp50_ = NULL;
		KkcUserRule* _tmp51_;
		KkcContext* _tmp52_;
		_tmp51_ = kkc_user_rule_new (parent_metadata, base_dir, "ibus-kkc", &_inner_error_);
		_tmp50_ = _tmp51_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp52_ = self->priv->context;
		kkc_context_set_typing_rule (_tmp52_, (KkcRule*) _tmp50_);
		_g_object_unref0 (_tmp50_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GVariant* _tmp53_;
		const gchar* _tmp54_;
		GError* _tmp55_;
		const gchar* _tmp56_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp53_ = variant;
		_tmp54_ = g_variant_get_string (_tmp53_, NULL);
		_tmp55_ = e;
		_tmp56_ = _tmp55_->message;
		g_warning ("engine.vala:405: can't load typing rule %s: %s", _tmp54_, _tmp56_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (base_dir);
		_g_object_unref0 (parent_metadata);
		_g_variant_unref0 (variant);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp57_ = kkc_engine_preferences;
	_tmp58_ = preferences_get (_tmp57_, "use_custom_keymap");
	_g_variant_unref0 (variant);
	variant = _tmp58_;
	_tmp59_ = variant;
	_vala_assert (_tmp59_ != NULL, "variant != null");
	_tmp60_ = variant;
	_tmp61_ = g_variant_get_boolean (_tmp60_);
	self->priv->use_custom_keymap = _tmp61_;
	_tmp62_ = kkc_engine_preferences;
	_tmp63_ = preferences_get (_tmp62_, "keymap");
	_g_variant_unref0 (variant);
	variant = _tmp63_;
	_tmp64_ = variant;
	_vala_assert (_tmp64_ != NULL, "variant != null");
	_tmp65_ = variant;
	_tmp66_ = g_variant_get_string (_tmp65_, NULL);
	_tmp67_ = ibus_keymap_get (_tmp66_);
	_tmp68_ = _g_object_ref0 (_tmp67_);
	_g_object_unref0 (self->priv->keymap);
	self->priv->keymap = _tmp68_;
	_g_free0 (base_dir);
	_g_object_unref0 (parent_metadata);
	_g_variant_unref0 (variant);
}


static IBusProperty* kkc_engine_register_input_mode_property (KkcEngine* self, KkcInputMode mode, const gchar* name, const gchar* label, const gchar* symbol) {
	IBusProperty* result = NULL;
	IBusProperty* prop = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	IBusText* _tmp2_;
	IBusText* _tmp3_;
	IBusProperty* _tmp4_;
	IBusProperty* _tmp5_;
	GeeMap* _tmp6_;
	KkcInputMode _tmp7_;
	GeeMap* _tmp8_;
	KkcInputMode _tmp9_;
	const gchar* _tmp10_;
	GeeMap* _tmp11_;
	const gchar* _tmp12_;
	KkcInputMode _tmp13_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (symbol != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = label;
	_tmp2_ = ibus_text_new_from_string (_tmp1_);
	g_object_ref_sink (_tmp2_);
	_tmp3_ = _tmp2_;
	_tmp4_ = ibus_property_new (_tmp0_, PROP_TYPE_RADIO, _tmp3_, NULL, NULL, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp3_);
	prop = _tmp5_;
	_tmp6_ = self->priv->input_mode_props;
	_tmp7_ = mode;
	gee_map_set (_tmp6_, (gpointer) ((gintptr) _tmp7_), prop);
	_tmp8_ = self->priv->input_mode_symbols;
	_tmp9_ = mode;
	_tmp10_ = symbol;
	gee_map_set (_tmp8_, (gpointer) ((gintptr) _tmp9_), _tmp10_);
	_tmp11_ = self->priv->name_input_modes;
	_tmp12_ = name;
	_tmp13_ = mode;
	gee_map_set (_tmp11_, _tmp12_, (gpointer) ((gintptr) _tmp13_));
	result = prop;
	return result;
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


static gboolean _vala_string_array_contains (const gchar* * stack, int stack_length, const gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static gboolean kkc_engine_process_lookup_table_key_event (KkcEngine* self, guint keyval, guint keycode, guint state) {
	gboolean result = FALSE;
	guint page_size = 0U;
	IBusLookupTable* _tmp0_;
	guint _tmp1_;
	gboolean _tmp2_ = FALSE;
	guint _tmp3_;
	guint _tmp23_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->lookup_table;
	_tmp1_ = ibus_lookup_table_get_page_size (_tmp0_);
	page_size = _tmp1_;
	_tmp3_ = state;
	if (_tmp3_ == ((guint) 0)) {
		guint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = keyval;
		_tmp5_ = g_unichar_to_string ((gunichar) _tmp4_);
		_tmp6_ = _tmp5_;
		_tmp2_ = _vala_string_array_contains (KKC_ENGINE_LOOKUP_TABLE_LABELS, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), _tmp6_);
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gchar* label = NULL;
		guint _tmp7_;
		gunichar _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = keyval;
		_tmp8_ = g_unichar_tolower ((gunichar) _tmp7_);
		_tmp9_ = g_unichar_to_string (_tmp8_);
		label = _tmp9_;
		{
			gint index = 0;
			index = 0;
			{
				gboolean _tmp10_ = FALSE;
				_tmp10_ = TRUE;
				while (TRUE) {
					gint _tmp12_;
					guint _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					const gchar* _tmp16_;
					const gchar* _tmp17_;
					if (!_tmp10_) {
						gint _tmp11_;
						_tmp11_ = index;
						index = _tmp11_ + 1;
					}
					_tmp10_ = FALSE;
					_tmp12_ = index;
					_tmp13_ = page_size;
					_tmp14_ = MIN ((gint) _tmp13_, G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS));
					if (!(_tmp12_ < _tmp14_)) {
						break;
					}
					_tmp15_ = index;
					_tmp16_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[_tmp15_];
					_tmp17_ = label;
					if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
						KkcContext* _tmp18_;
						KkcCandidateList* _tmp19_;
						KkcCandidateList* _tmp20_;
						gint _tmp21_;
						gboolean _tmp22_;
						_tmp18_ = self->priv->context;
						_tmp19_ = kkc_context_get_candidates (_tmp18_);
						_tmp20_ = _tmp19_;
						_tmp21_ = index;
						_tmp22_ = kkc_candidate_list_select_at (_tmp20_, (guint) _tmp21_);
						result = _tmp22_;
						_g_free0 (label);
						return result;
					}
				}
			}
		}
		result = FALSE;
		_g_free0 (label);
		return result;
	}
	_tmp23_ = state;
	if (_tmp23_ == ((guint) 0)) {
		gboolean retval = FALSE;
		guint _tmp24_;
		gboolean _tmp41_;
		retval = FALSE;
		_tmp24_ = keyval;
		switch (_tmp24_) {
			case IBUS_Page_Up:
			case IBUS_KP_Page_Up:
			{
				KkcContext* _tmp25_;
				KkcCandidateList* _tmp26_;
				KkcCandidateList* _tmp27_;
				gboolean _tmp28_;
				_tmp25_ = self->priv->context;
				_tmp26_ = kkc_context_get_candidates (_tmp25_);
				_tmp27_ = _tmp26_;
				_tmp28_ = kkc_candidate_list_page_up (_tmp27_);
				retval = _tmp28_;
				break;
			}
			case IBUS_Page_Down:
			case IBUS_KP_Page_Down:
			{
				KkcContext* _tmp29_;
				KkcCandidateList* _tmp30_;
				KkcCandidateList* _tmp31_;
				gboolean _tmp32_;
				_tmp29_ = self->priv->context;
				_tmp30_ = kkc_context_get_candidates (_tmp29_);
				_tmp31_ = _tmp30_;
				_tmp32_ = kkc_candidate_list_page_down (_tmp31_);
				retval = _tmp32_;
				break;
			}
			case IBUS_Up:
			{
				KkcContext* _tmp33_;
				KkcCandidateList* _tmp34_;
				KkcCandidateList* _tmp35_;
				gboolean _tmp36_;
				_tmp33_ = self->priv->context;
				_tmp34_ = kkc_context_get_candidates (_tmp33_);
				_tmp35_ = _tmp34_;
				_tmp36_ = kkc_candidate_list_cursor_up (_tmp35_);
				retval = _tmp36_;
				break;
			}
			case IBUS_Down:
			{
				KkcContext* _tmp37_;
				KkcCandidateList* _tmp38_;
				KkcCandidateList* _tmp39_;
				gboolean _tmp40_;
				_tmp37_ = self->priv->context;
				_tmp38_ = kkc_context_get_candidates (_tmp37_);
				_tmp39_ = _tmp38_;
				_tmp40_ = kkc_candidate_list_cursor_down (_tmp39_);
				retval = _tmp40_;
				break;
			}
			default:
			{
				result = FALSE;
				return result;
			}
		}
		_tmp41_ = retval;
		if (_tmp41_) {
			kkc_engine_set_lookup_table_cursor_pos (self);
			kkc_engine_update_preedit (self);
		}
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}


static gboolean kkc_engine_real_process_key_event (IBusEngine* base, guint keyval, guint keycode, guint state) {
	KkcEngine * self;
	gboolean result = FALSE;
	guint _keyval = 0U;
	guint _tmp0_;
	gboolean _tmp1_;
	guint _state = 0U;
	guint _tmp6_;
	gboolean _tmp7_ = FALSE;
	KkcContext* _tmp8_;
	KkcCandidateList* _tmp9_;
	KkcCandidateList* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	KkcKeyEvent* key = NULL;
	guint _tmp17_;
	guint _tmp18_;
	guint _tmp19_;
	KkcKeyEvent* _tmp20_;
	gboolean retval = FALSE;
	KkcContext* _tmp21_;
	KkcKeyEvent* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	self = (KkcEngine*) base;
	_tmp0_ = keyval;
	_keyval = _tmp0_;
	_tmp1_ = self->priv->use_custom_keymap;
	if (_tmp1_) {
		IBusKeymap* _tmp2_;
		guint _tmp3_;
		guint _tmp4_;
		guint _tmp5_;
		_tmp2_ = self->priv->keymap;
		_tmp3_ = keycode;
		_tmp4_ = state;
		_tmp5_ = ibus_keymap_lookup_keysym (_tmp2_, (guint16) _tmp3_, (guint32) _tmp4_);
		_keyval = _tmp5_;
	}
	_tmp6_ = state;
	_state = _tmp6_ & ((((IBUS_SHIFT_MASK | IBUS_CONTROL_MASK) | IBUS_MOD1_MASK) | IBUS_MOD5_MASK) | IBUS_RELEASE_MASK);
	_tmp8_ = self->priv->context;
	_tmp9_ = kkc_context_get_candidates (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = kkc_candidate_list_get_page_visible (_tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_) {
		guint _tmp13_;
		guint _tmp14_;
		guint _tmp15_;
		gboolean _tmp16_;
		_tmp13_ = _keyval;
		_tmp14_ = keycode;
		_tmp15_ = _state;
		_tmp16_ = kkc_engine_process_lookup_table_key_event (self, _tmp13_, _tmp14_, _tmp15_);
		_tmp7_ = _tmp16_;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		result = TRUE;
		return result;
	}
	_tmp17_ = _keyval;
	_tmp18_ = keycode;
	_tmp19_ = _state;
	_tmp20_ = kkc_key_event_new_from_x_event (_tmp17_, _tmp18_, (KkcModifierType) _tmp19_);
	key = _tmp20_;
	_tmp21_ = self->priv->context;
	_tmp22_ = key;
	_tmp23_ = kkc_context_process_key_event (_tmp21_, _tmp22_);
	retval = _tmp23_;
	_tmp29_ = retval;
	if (!_tmp29_) {
		gboolean _tmp30_;
		_tmp30_ = self->priv->use_custom_keymap;
		_tmp28_ = _tmp30_;
	} else {
		_tmp28_ = FALSE;
	}
	if (_tmp28_) {
		guint _tmp31_;
		guint _tmp32_;
		_tmp31_ = _keyval;
		_tmp32_ = keyval;
		_tmp27_ = _tmp31_ != _tmp32_;
	} else {
		_tmp27_ = FALSE;
	}
	if (_tmp27_) {
		guint _tmp33_;
		_tmp33_ = _keyval;
		_tmp26_ = ((guint) 0x20) <= _tmp33_;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		guint _tmp34_;
		_tmp34_ = _keyval;
		_tmp25_ = _tmp34_ <= ((guint) 0x7F);
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		guint _tmp35_;
		_tmp35_ = state;
		_tmp24_ = (_tmp35_ & IBUS_RELEASE_MASK) == ((guint) 0);
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		GString* builder = NULL;
		GString* _tmp36_;
		GString* _tmp37_;
		guint _tmp38_;
		IBusText* text = NULL;
		GString* _tmp39_;
		const gchar* _tmp40_;
		IBusText* _tmp41_;
		IBusText* _tmp42_;
		_tmp36_ = g_string_new ("");
		builder = _tmp36_;
		_tmp37_ = builder;
		_tmp38_ = _keyval;
		g_string_append_c (_tmp37_, (gchar) _tmp38_);
		_tmp39_ = builder;
		_tmp40_ = _tmp39_->str;
		_tmp41_ = ibus_text_new_from_string (_tmp40_);
		g_object_ref_sink (_tmp41_);
		text = _tmp41_;
		_tmp42_ = text;
		ibus_engine_commit_text ((IBusEngine*) self, _tmp42_);
		result = TRUE;
		_g_object_unref0 (text);
		_g_string_free0 (builder);
		_g_object_unref0 (key);
		return result;
	}
	result = retval;
	_g_object_unref0 (key);
	return result;
}


static gboolean __lambda4_ (KkcEngine* self) {
	gboolean result = FALSE;
	KkcContext* _tmp0_;
	KkcDictionaryList* _tmp1_;
	KkcDictionaryList* _tmp2_;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_dictionaries (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_dictionary_list_save (_tmp2_);
	result = TRUE;
	return result;
}


static gboolean ___lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda4_ ((KkcEngine*) self);
	return result;
}


static void kkc_engine_real_enable (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	guint _tmp1_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = g_timeout_add_seconds_full (G_PRIORITY_LOW, (guint) 300, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->save_dictionaries_timeout_id = _tmp1_;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void kkc_engine_real_disable (IBusEngine* base) {
	KkcEngine * self;
	guint _tmp0_;
	KkcContext* _tmp2_;
	KkcDictionaryList* _tmp3_;
	KkcDictionaryList* _tmp4_;
	self = (KkcEngine*) base;
	g_signal_emit_by_name ((IBusEngine*) self, "focus-out");
	_tmp0_ = self->priv->save_dictionaries_timeout_id;
	if (_tmp0_ > ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->save_dictionaries_timeout_id;
		g_source_remove (_tmp1_);
		self->priv->save_dictionaries_timeout_id = (guint) 0;
	}
	_tmp2_ = self->priv->context;
	_tmp3_ = kkc_context_get_dictionaries (_tmp2_);
	_tmp4_ = _tmp3_;
	kkc_dictionary_list_save (_tmp4_);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void kkc_engine_real_reset (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	IBusText* empty_text = NULL;
	IBusText* _tmp1_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	_tmp1_ = ibus_text_new_from_static_string ("");
	g_object_ref_sink (_tmp1_);
	empty_text = _tmp1_;
	ibus_engine_update_preedit_text ((IBusEngine*) self, empty_text, (guint) 0, FALSE);
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->reset (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
	_g_object_unref0 (empty_text);
}


static void kkc_engine_real_focus_in (IBusEngine* base) {
	KkcEngine * self;
	IBusPropList* _tmp0_;
	self = (KkcEngine*) base;
	kkc_engine_update_input_mode (self);
	_tmp0_ = self->priv->prop_list;
	ibus_engine_register_properties ((IBusEngine*) self, _tmp0_);
	self->priv->properties_registered = TRUE;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_in (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void kkc_engine_real_focus_out (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	kkc_context_reset (_tmp0_);
	ibus_engine_hide_preedit_text ((IBusEngine*) self);
	ibus_engine_hide_lookup_table ((IBusEngine*) self);
	self->priv->properties_registered = FALSE;
	IBUS_ENGINE_CLASS (kkc_engine_parent_class)->focus_out (G_TYPE_CHECK_INSTANCE_CAST (self, IBUS_TYPE_ENGINE, IBusEngine));
}


static void kkc_engine_real_property_activate (IBusEngine* base, const gchar* prop_name, guint prop_state) {
	KkcEngine * self;
	const gchar* _tmp0_;
	GError * _inner_error_ = NULL;
	self = (KkcEngine*) base;
	g_return_if_fail (prop_name != NULL);
	_tmp0_ = prop_name;
	if (g_strcmp0 (_tmp0_, "setup") == 0) {
		gchar* filename = NULL;
		gchar* _tmp1_;
		_tmp1_ = g_build_filename (LIBEXECDIR, "ibus-setup-kkc", NULL);
		filename = _tmp1_;
		{
			const gchar* _tmp2_;
			_tmp2_ = filename;
			g_spawn_command_line_async (_tmp2_, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == G_SPAWN_ERROR) {
					goto __catch3_g_spawn_error;
				}
				_g_free0 (filename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
		goto __finally3;
		__catch3_g_spawn_error:
		{
			GError* e = NULL;
			const gchar* _tmp3_;
			GError* _tmp4_;
			const gchar* _tmp5_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = filename;
			_tmp4_ = e;
			_tmp5_ = _tmp4_->message;
			g_warning ("engine.vala:597: can't spawn %s: %s", _tmp3_, _tmp5_);
			_g_error_free0 (e);
		}
		__finally3:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (filename);
	} else {
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = prop_name;
		_tmp8_ = g_str_has_prefix (_tmp7_, "InputMode.");
		if (_tmp8_) {
			guint _tmp9_;
			_tmp9_ = prop_state;
			_tmp6_ = _tmp9_ == ((guint) PROP_STATE_CHECKED);
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			KkcContext* _tmp10_;
			GeeMap* _tmp11_;
			const gchar* _tmp12_;
			gpointer _tmp13_;
			_tmp10_ = self->priv->context;
			_tmp11_ = self->priv->name_input_modes;
			_tmp12_ = prop_name;
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
			kkc_context_set_input_mode (_tmp10_, (KkcInputMode) ((gintptr) _tmp13_));
		}
	}
}


static void kkc_engine_real_candidate_clicked (IBusEngine* base, guint index, guint button, guint state) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	guint _tmp3_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = index;
	kkc_candidate_list_select_at (_tmp2_, _tmp3_);
}


static void kkc_engine_real_cursor_up (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_cursor_up (_tmp2_);
}


static void kkc_engine_real_cursor_down (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_cursor_down (_tmp2_);
}


static void kkc_engine_real_page_up (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_page_up (_tmp2_);
}


static void kkc_engine_real_page_down (IBusEngine* base) {
	KkcEngine * self;
	KkcContext* _tmp0_;
	KkcCandidateList* _tmp1_;
	KkcCandidateList* _tmp2_;
	self = (KkcEngine*) base;
	_tmp0_ = self->priv->context;
	_tmp1_ = kkc_context_get_candidates (_tmp0_);
	_tmp2_ = _tmp1_;
	kkc_candidate_list_page_down (_tmp2_);
}


static void kkc_engine_real_set_content_type (IBusEngine* base, guint purpose, guint hints) {
	KkcEngine * self;
	guint _tmp0_;
	self = (KkcEngine*) base;
	_tmp0_ = purpose;
	switch (_tmp0_) {
		case IBUS_INPUT_PURPOSE_PASSWORD:
		case IBUS_INPUT_PURPOSE_PIN:
		{
			KkcContext* _tmp1_;
			_tmp1_ = self->priv->context;
			kkc_context_set_input_mode (_tmp1_, KKC_INPUT_MODE_DIRECT);
			break;
		}
		case IBUS_INPUT_PURPOSE_ALPHA:
		case IBUS_INPUT_PURPOSE_DIGITS:
		case IBUS_INPUT_PURPOSE_NUMBER:
		case IBUS_INPUT_PURPOSE_PHONE:
		case IBUS_INPUT_PURPOSE_URL:
		case IBUS_INPUT_PURPOSE_EMAIL:
		{
			KkcContext* _tmp2_;
			_tmp2_ = self->priv->context;
			kkc_context_set_input_mode (_tmp2_, KKC_INPUT_MODE_LATIN);
			break;
		}
		default:
		break;
	}
}


static void __lambda5_ (void) {
	ibus_quit ();
}


static void ___lambda5__ibus_bus_disconnected (IBusBus* _sender, gpointer self) {
	__lambda5_ ();
}


static void __lambda6_ (const gchar* name, GVariant* value) {
	const gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	_tmp0_ = name;
	if (g_strcmp0 (_tmp0_, "dictionaries") == 0) {
		kkc_engine_reload_dictionaries ();
	}
}


static void ___lambda6__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self) {
	__lambda6_ (name, value);
}


gint kkc_engine_main (gchar** args, int args_length1) {
	gint result = 0;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	IBusBus* bus = NULL;
	IBusBus* _tmp8_;
	IBusBus* _tmp9_;
	gboolean _tmp10_;
	IBusBus* _tmp12_;
	IBusConfig* config = NULL;
	IBusBus* _tmp13_;
	IBusConfig* _tmp14_;
	IBusConfig* _tmp15_;
	IBusConfig* _tmp16_;
	IBusConfig* _tmp25_;
	Preferences* _tmp26_;
	GeeArrayList* _tmp27_;
	Preferences* _tmp28_;
	IBusFactory* factory = NULL;
	IBusBus* _tmp29_;
	GDBusConnection* _tmp30_;
	IBusFactory* _tmp31_;
	IBusFactory* _tmp32_;
	gboolean _tmp33_;
	GError * _inner_error_ = NULL;
	ibus_init ();
	kkc_init ();
	gtk_init (&args_length1, &args);
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = g_option_context_new ("- ibus kkc");
	context = _tmp0_;
	_tmp1_ = context;
	g_option_context_add_main_entries (_tmp1_, KKC_ENGINE_options, "ibus-kkc");
	{
		GOptionContext* _tmp2_;
		_tmp2_ = context;
		g_option_context_parse (_tmp2_, &args_length1, &args, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gint _tmp3_ = 0;
			if (_inner_error_->domain == G_OPTION_ERROR) {
				goto __catch4_g_option_error;
			}
			_g_option_context_free0 (context);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp3_;
		}
	}
	goto __finally4;
	__catch4_g_option_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = stderr;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		fprintf (_tmp4_, "%s\n", _tmp6_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (context);
		return result;
	}
	__finally4:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp7_ = 0;
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp7_;
	}
	_tmp8_ = ibus_bus_new ();
	g_object_ref_sink (_tmp8_);
	bus = _tmp8_;
	_tmp9_ = bus;
	_tmp10_ = ibus_bus_is_connected (_tmp9_);
	if (!_tmp10_) {
		FILE* _tmp11_;
		_tmp11_ = stderr;
		fprintf (_tmp11_, "cannot connect to ibus-daemon!\n");
		result = 1;
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	_tmp12_ = bus;
	g_signal_connect (_tmp12_, "disconnected", (GCallback) ___lambda5__ibus_bus_disconnected, NULL);
	_tmp13_ = bus;
	_tmp14_ = ibus_bus_get_config (_tmp13_);
	_tmp15_ = _g_object_ref0 (_tmp14_);
	config = _tmp15_;
	_tmp16_ = config;
	if (_tmp16_ == NULL) {
		FILE* _tmp17_;
		_tmp17_ = stderr;
		fprintf (_tmp17_, "ibus-config component is not running!\n");
		result = 1;
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	{
		KkcLanguageModel* _tmp18_ = NULL;
		KkcLanguageModel* _tmp19_;
		KkcLanguageModel* _tmp20_;
		_tmp19_ = kkc_language_model_load ("sorted3", &_inner_error_);
		_tmp18_ = _tmp19_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch5_g_error;
		}
		_tmp20_ = _tmp18_;
		_tmp18_ = NULL;
		_g_object_unref0 (kkc_engine_language_model);
		kkc_engine_language_model = _tmp20_;
		_g_object_unref0 (_tmp18_);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		FILE* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp21_ = stderr;
		_tmp22_ = e;
		_tmp23_ = _tmp22_->message;
		fprintf (_tmp21_, "can't load language model: %s\n", _tmp23_);
		result = 1;
		_g_error_free0 (e);
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		return result;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gint _tmp24_ = 0;
		_g_object_unref0 (config);
		_g_object_unref0 (bus);
		_g_option_context_free0 (context);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp24_;
	}
	_tmp25_ = config;
	_tmp26_ = preferences_new (_tmp25_);
	_g_object_unref0 (kkc_engine_preferences);
	kkc_engine_preferences = _tmp26_;
	_tmp27_ = gee_array_list_new (KKC_TYPE_DICTIONARY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (kkc_engine_dictionaries);
	kkc_engine_dictionaries = _tmp27_;
	kkc_engine_reload_dictionaries ();
	_tmp28_ = kkc_engine_preferences;
	g_signal_connect (_tmp28_, "value-changed", (GCallback) ___lambda6__preferences_value_changed, NULL);
	_tmp29_ = bus;
	_tmp30_ = ibus_bus_get_connection (_tmp29_);
	_tmp31_ = ibus_factory_new (_tmp30_);
	g_object_ref_sink (_tmp31_);
	factory = _tmp31_;
	_tmp32_ = factory;
	ibus_factory_add_engine (_tmp32_, "kkc", TYPE_KKC_ENGINE);
	_tmp33_ = kkc_engine_ibus;
	if (_tmp33_) {
		IBusBus* _tmp34_;
		_tmp34_ = bus;
		ibus_bus_request_name (_tmp34_, "org.freedesktop.IBus.KKC", (guint32) 0);
	} else {
		IBusComponent* component = NULL;
		IBusComponent* _tmp35_;
		IBusEngineDesc* engine = NULL;
		gchar* _tmp36_;
		gchar* _tmp37_;
		IBusEngineDesc* _tmp38_;
		IBusEngineDesc* _tmp39_;
		IBusComponent* _tmp40_;
		IBusEngineDesc* _tmp41_;
		IBusBus* _tmp42_;
		IBusComponent* _tmp43_;
		_tmp35_ = ibus_component_new ("org.freedesktop.IBus.KKC", N_ ("Kana Kanji"), PACKAGE_VERSION, "GPL", "Daiki Ueno <ueno@gnu.org>", "https://github.com/ueno/ibus-kkc", "", "ibus-kkc");
		g_object_ref_sink (_tmp35_);
		component = _tmp35_;
		_tmp36_ = g_strdup_printf ("%s/icons/ibus-kkc.svg", PACKAGE_DATADIR);
		_tmp37_ = _tmp36_;
		_tmp38_ = ibus_engine_desc_new ("kkc", "Kana Kanji", "Kana Kanji Input Method", "ja", "GPL", "Daiki Ueno <ueno@gnu.org>", _tmp37_, "us");
		g_object_ref_sink (_tmp38_);
		_tmp39_ = _tmp38_;
		_g_free0 (_tmp37_);
		engine = _tmp39_;
		_tmp40_ = component;
		_tmp41_ = engine;
		ibus_component_add_engine (_tmp40_, _tmp41_);
		_tmp42_ = bus;
		_tmp43_ = component;
		ibus_bus_register_component (_tmp42_, _tmp43_);
		_g_object_unref0 (engine);
		_g_object_unref0 (component);
	}
	ibus_main ();
	result = 0;
	_g_object_unref0 (factory);
	_g_object_unref0 (config);
	_g_object_unref0 (bus);
	_g_option_context_free0 (context);
	return result;
}


int main (int argc, char ** argv) {
	return kkc_engine_main (argv, argc);
}


KkcEngine* kkc_engine_construct (GType object_type) {
	KkcEngine * self = NULL;
	self = (KkcEngine*) g_object_new (object_type, NULL);
	return self;
}


KkcEngine* kkc_engine_new (void) {
	return kkc_engine_construct (TYPE_KKC_ENGINE);
}


static void _kkc_engine___lambda7_ (KkcEngine* self, const gchar* name, GVariant* value) {
	const gchar* _tmp0_;
	g_return_if_fail (name != NULL);
	g_return_if_fail (value != NULL);
	kkc_engine_apply_preferences (self);
	_tmp0_ = name;
	if (g_strcmp0 (_tmp0_, "dictionaries") == 0) {
		KkcContext* _tmp1_;
		KkcDictionaryList* _tmp2_;
		KkcDictionaryList* _tmp3_;
		_tmp1_ = self->priv->context;
		_tmp2_ = kkc_context_get_dictionaries (_tmp1_);
		_tmp3_ = _tmp2_;
		kkc_dictionary_list_clear (_tmp3_);
		{
			GeeArrayList* _dictionary_list = NULL;
			GeeArrayList* _tmp4_;
			GeeArrayList* _tmp5_;
			gint _dictionary_size = 0;
			GeeArrayList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _dictionary_index = 0;
			_tmp4_ = kkc_engine_dictionaries;
			_tmp5_ = _g_object_ref0 (_tmp4_);
			_dictionary_list = _tmp5_;
			_tmp6_ = _dictionary_list;
			_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
			_tmp8_ = _tmp7_;
			_dictionary_size = _tmp8_;
			_dictionary_index = -1;
			while (TRUE) {
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				KkcDictionary* dictionary = NULL;
				GeeArrayList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_;
				KkcContext* _tmp15_;
				KkcDictionaryList* _tmp16_;
				KkcDictionaryList* _tmp17_;
				KkcDictionary* _tmp18_;
				_tmp9_ = _dictionary_index;
				_dictionary_index = _tmp9_ + 1;
				_tmp10_ = _dictionary_index;
				_tmp11_ = _dictionary_size;
				if (!(_tmp10_ < _tmp11_)) {
					break;
				}
				_tmp12_ = _dictionary_list;
				_tmp13_ = _dictionary_index;
				_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _tmp13_);
				dictionary = (KkcDictionary*) _tmp14_;
				_tmp15_ = self->priv->context;
				_tmp16_ = kkc_context_get_dictionaries (_tmp15_);
				_tmp17_ = _tmp16_;
				_tmp18_ = dictionary;
				kkc_dictionary_list_add (_tmp17_, _tmp18_);
				_g_object_unref0 (dictionary);
			}
			_g_object_unref0 (_dictionary_list);
		}
	}
}


static void __kkc_engine___lambda7__preferences_value_changed (Preferences* _sender, const gchar* name, GVariant* value, gpointer self) {
	_kkc_engine___lambda7_ ((KkcEngine*) self, name, value);
}


static void _kkc_engine___lambda8_ (KkcEngine* self) {
	kkc_engine_update_preedit (self);
}


static void __kkc_engine___lambda8__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda8_ ((KkcEngine*) self);
}


static void _kkc_engine___lambda9_ (KkcEngine* self, GObject* s, GParamSpec* p) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	kkc_engine_update_input_mode (self);
}


static void __kkc_engine___lambda9__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda9_ ((KkcEngine*) self, _sender, pspec);
}


static void _kkc_engine___lambda10_ (KkcEngine* self) {
	kkc_engine_populate_lookup_table (self);
}


static void __kkc_engine___lambda10__kkc_candidate_list_populated (KkcCandidateList* _sender, gpointer self) {
	_kkc_engine___lambda10_ ((KkcEngine*) self);
}


static void _kkc_engine___lambda11_ (KkcEngine* self) {
	kkc_engine_set_lookup_table_cursor_pos (self);
}


static void __kkc_engine___lambda11__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	_kkc_engine___lambda11_ ((KkcEngine*) self);
}


static void _kkc_engine___lambda12_ (KkcEngine* self) {
	gboolean _tmp0_;
	_tmp0_ = self->priv->lookup_table_visible;
	if (_tmp0_) {
		ibus_engine_hide_lookup_table ((IBusEngine*) self);
		ibus_engine_hide_auxiliary_text ((IBusEngine*) self);
		self->priv->lookup_table_visible = FALSE;
	}
}


static void __kkc_engine___lambda12__kkc_candidate_list_selected (KkcCandidateList* _sender, KkcCandidate* candidate, gpointer self) {
	_kkc_engine___lambda12_ ((KkcEngine*) self);
}


static void _kkc_engine___lambda13_ (KkcEngine* self, KkcContext* e) {
	GtkClipboard* _tmp0_;
	g_return_if_fail (e != NULL);
	_tmp0_ = self->priv->clipboard;
	gtk_clipboard_request_text (_tmp0_, (GtkClipboardTextReceivedFunc) kkc_engine_set_selection_text, self);
}


static void __kkc_engine___lambda13__kkc_context_request_selection_text (KkcContext* _sender, gpointer self) {
	_kkc_engine___lambda13_ ((KkcEngine*) self, _sender);
}


static GObject * kkc_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	KkcEngine * self;
	IBusLookupTable* _tmp0_;
	IBusPropList* _tmp10_;
	IBusPropList* props = NULL;
	IBusPropList* _tmp11_;
	IBusProperty* prop = NULL;
	IBusProperty* _tmp12_;
	IBusPropList* _tmp13_;
	IBusProperty* _tmp14_;
	IBusProperty* _tmp15_;
	IBusPropList* _tmp16_;
	IBusProperty* _tmp17_;
	IBusProperty* _tmp18_;
	IBusPropList* _tmp19_;
	IBusProperty* _tmp20_;
	IBusProperty* _tmp21_;
	IBusPropList* _tmp22_;
	IBusProperty* _tmp23_;
	IBusProperty* _tmp24_;
	IBusPropList* _tmp25_;
	IBusProperty* _tmp26_;
	IBusProperty* _tmp27_;
	IBusPropList* _tmp28_;
	IBusProperty* _tmp29_;
	IBusText* _tmp30_;
	IBusText* _tmp31_;
	IBusText* _tmp32_;
	IBusText* _tmp33_;
	IBusPropList* _tmp34_;
	IBusProperty* _tmp35_;
	IBusPropList* _tmp36_;
	IBusProperty* _tmp37_;
	IBusProperty* _tmp38_;
	IBusProperty* _tmp39_;
	IBusText* _tmp40_;
	IBusText* _tmp41_;
	IBusText* _tmp42_;
	IBusText* _tmp43_;
	IBusProperty* _tmp44_;
	IBusPropList* _tmp45_;
	IBusProperty* _tmp46_;
	KkcLanguageModel* _tmp47_;
	KkcContext* _tmp48_;
	Preferences* _tmp64_;
	KkcContext* _tmp65_;
	KkcContext* _tmp66_;
	KkcContext* _tmp67_;
	KkcCandidateList* _tmp68_;
	KkcCandidateList* _tmp69_;
	KkcContext* _tmp70_;
	KkcCandidateList* _tmp71_;
	KkcCandidateList* _tmp72_;
	KkcContext* _tmp73_;
	KkcCandidateList* _tmp74_;
	KkcCandidateList* _tmp75_;
	GtkClipboard* _tmp76_;
	GtkClipboard* _tmp77_;
	KkcContext* _tmp78_;
	parent_class = G_OBJECT_CLASS (kkc_engine_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
	_tmp0_ = ibus_lookup_table_new ((guint) G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS), (guint) 0, TRUE, TRUE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->lookup_table);
	self->priv->lookup_table = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				IBusText* text = NULL;
				gint _tmp4_;
				const gchar* _tmp5_;
				IBusText* _tmp6_;
				IBusLookupTable* _tmp7_;
				gint _tmp8_;
				IBusText* _tmp9_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = i;
				if (!(_tmp3_ < G_N_ELEMENTS (KKC_ENGINE_LOOKUP_TABLE_LABELS))) {
					break;
				}
				_tmp4_ = i;
				_tmp5_ = KKC_ENGINE_LOOKUP_TABLE_LABELS[_tmp4_];
				_tmp6_ = ibus_text_new_from_string (_tmp5_);
				g_object_ref_sink (_tmp6_);
				text = _tmp6_;
				_tmp7_ = self->priv->lookup_table;
				_tmp8_ = i;
				_tmp9_ = text;
				ibus_lookup_table_set_label (_tmp7_, (guint) _tmp8_, _tmp9_);
				_g_object_unref0 (text);
			}
		}
	}
	_tmp10_ = ibus_prop_list_new ();
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->prop_list);
	self->priv->prop_list = _tmp10_;
	_tmp11_ = ibus_prop_list_new ();
	g_object_ref_sink (_tmp11_);
	props = _tmp11_;
	_tmp12_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HIRAGANA, "InputMode.Hiragana", _ ("Hiragana"), "あ");
	_g_object_unref0 (prop);
	prop = _tmp12_;
	_tmp13_ = props;
	_tmp14_ = prop;
	ibus_prop_list_append (_tmp13_, _tmp14_);
	_tmp15_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_KATAKANA, "InputMode.Katakana", _ ("Katakana"), "ア");
	_g_object_unref0 (prop);
	prop = _tmp15_;
	_tmp16_ = props;
	_tmp17_ = prop;
	ibus_prop_list_append (_tmp16_, _tmp17_);
	_tmp18_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_HANKAKU_KATAKANA, "InputMode.HankakuKatakana", _ ("Halfwidth Katakana"), "_ｱ");
	_g_object_unref0 (prop);
	prop = _tmp18_;
	_tmp19_ = props;
	_tmp20_ = prop;
	ibus_prop_list_append (_tmp19_, _tmp20_);
	_tmp21_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_LATIN, "InputMode.Latin", _ ("Latin"), "_A");
	_g_object_unref0 (prop);
	prop = _tmp21_;
	_tmp22_ = props;
	_tmp23_ = prop;
	ibus_prop_list_append (_tmp22_, _tmp23_);
	_tmp24_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_WIDE_LATIN, "InputMode.WideLatin", _ ("Wide Latin"), "Ａ");
	_g_object_unref0 (prop);
	prop = _tmp24_;
	_tmp25_ = props;
	_tmp26_ = prop;
	ibus_prop_list_append (_tmp25_, _tmp26_);
	_tmp27_ = kkc_engine_register_input_mode_property (self, KKC_INPUT_MODE_DIRECT, "InputMode.Direct", _ ("Direct Input"), "_A");
	_g_object_unref0 (prop);
	prop = _tmp27_;
	_tmp28_ = props;
	_tmp29_ = prop;
	ibus_prop_list_append (_tmp28_, _tmp29_);
	_tmp30_ = ibus_text_new_from_string ("あ");
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	_tmp32_ = ibus_text_new_from_string (_ ("Switch input mode"));
	g_object_ref_sink (_tmp32_);
	_tmp33_ = _tmp32_;
	_tmp34_ = props;
	_tmp35_ = ibus_property_new ("InputMode", PROP_TYPE_MENU, _tmp31_, NULL, _tmp33_, TRUE, TRUE, PROP_STATE_UNCHECKED, _tmp34_);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (prop);
	prop = _tmp35_;
	_g_object_unref0 (_tmp33_);
	_g_object_unref0 (_tmp31_);
	_tmp36_ = self->priv->prop_list;
	_tmp37_ = prop;
	ibus_prop_list_append (_tmp36_, _tmp37_);
	_tmp38_ = prop;
	_tmp39_ = _g_object_ref0 (_tmp38_);
	_g_object_unref0 (self->priv->input_mode_prop);
	self->priv->input_mode_prop = _tmp39_;
	_tmp40_ = ibus_text_new_from_string (_ ("Preferences"));
	g_object_ref_sink (_tmp40_);
	_tmp41_ = _tmp40_;
	_tmp42_ = ibus_text_new_from_string (_ ("Configure Kana Kanji Conversion"));
	g_object_ref_sink (_tmp42_);
	_tmp43_ = _tmp42_;
	_tmp44_ = ibus_property_new ("setup", PROP_TYPE_NORMAL, _tmp41_, "gtk-preferences", _tmp43_, TRUE, TRUE, PROP_STATE_UNCHECKED, NULL);
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (prop);
	prop = _tmp44_;
	_g_object_unref0 (_tmp43_);
	_g_object_unref0 (_tmp41_);
	_tmp45_ = self->priv->prop_list;
	_tmp46_ = prop;
	ibus_prop_list_append (_tmp45_, _tmp46_);
	_tmp47_ = kkc_engine_language_model;
	_tmp48_ = kkc_context_new (_tmp47_);
	_g_object_unref0 (self->priv->context);
	self->priv->context = _tmp48_;
	{
		GeeArrayList* _dictionary_list = NULL;
		GeeArrayList* _tmp49_;
		GeeArrayList* _tmp50_;
		gint _dictionary_size = 0;
		GeeArrayList* _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
		gint _dictionary_index = 0;
		_tmp49_ = kkc_engine_dictionaries;
		_tmp50_ = _g_object_ref0 (_tmp49_);
		_dictionary_list = _tmp50_;
		_tmp51_ = _dictionary_list;
		_tmp52_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp51_);
		_tmp53_ = _tmp52_;
		_dictionary_size = _tmp53_;
		_dictionary_index = -1;
		while (TRUE) {
			gint _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			KkcDictionary* dictionary = NULL;
			GeeArrayList* _tmp57_;
			gint _tmp58_;
			gpointer _tmp59_;
			KkcContext* _tmp60_;
			KkcDictionaryList* _tmp61_;
			KkcDictionaryList* _tmp62_;
			KkcDictionary* _tmp63_;
			_tmp54_ = _dictionary_index;
			_dictionary_index = _tmp54_ + 1;
			_tmp55_ = _dictionary_index;
			_tmp56_ = _dictionary_size;
			if (!(_tmp55_ < _tmp56_)) {
				break;
			}
			_tmp57_ = _dictionary_list;
			_tmp58_ = _dictionary_index;
			_tmp59_ = gee_abstract_list_get ((GeeAbstractList*) _tmp57_, _tmp58_);
			dictionary = (KkcDictionary*) _tmp59_;
			_tmp60_ = self->priv->context;
			_tmp61_ = kkc_context_get_dictionaries (_tmp60_);
			_tmp62_ = _tmp61_;
			_tmp63_ = dictionary;
			kkc_dictionary_list_add (_tmp62_, _tmp63_);
			_g_object_unref0 (dictionary);
		}
		_g_object_unref0 (_dictionary_list);
	}
	kkc_engine_apply_preferences (self);
	_tmp64_ = kkc_engine_preferences;
	g_signal_connect_object (_tmp64_, "value-changed", (GCallback) __kkc_engine___lambda7__preferences_value_changed, self, 0);
	_tmp65_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp65_, "notify::input", (GCallback) __kkc_engine___lambda8__g_object_notify, self, 0);
	_tmp66_ = self->priv->context;
	g_signal_connect_object ((GObject*) _tmp66_, "notify::input-mode", (GCallback) __kkc_engine___lambda9__g_object_notify, self, 0);
	_tmp67_ = self->priv->context;
	_tmp68_ = kkc_context_get_candidates (_tmp67_);
	_tmp69_ = _tmp68_;
	g_signal_connect_object (_tmp69_, "populated", (GCallback) __kkc_engine___lambda10__kkc_candidate_list_populated, self, 0);
	_tmp70_ = self->priv->context;
	_tmp71_ = kkc_context_get_candidates (_tmp70_);
	_tmp72_ = _tmp71_;
	g_signal_connect_object ((GObject*) _tmp72_, "notify::cursor-pos", (GCallback) __kkc_engine___lambda11__g_object_notify, self, 0);
	_tmp73_ = self->priv->context;
	_tmp74_ = kkc_context_get_candidates (_tmp73_);
	_tmp75_ = _tmp74_;
	g_signal_connect_object (_tmp75_, "selected", (GCallback) __kkc_engine___lambda12__kkc_candidate_list_selected, self, 0);
	_tmp76_ = gtk_clipboard_get (GDK_SELECTION_PRIMARY);
	_tmp77_ = _g_object_ref0 (_tmp76_);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->clipboard = _tmp77_;
	_tmp78_ = self->priv->context;
	g_signal_connect_object (_tmp78_, "request-selection-text", (GCallback) __kkc_engine___lambda13__kkc_context_request_selection_text, self, 0);
	kkc_engine_update_candidates (self);
	kkc_engine_update_input_mode (self);
	_g_object_unref0 (prop);
	_g_object_unref0 (props);
	return obj;
}


static void kkc_engine_class_init (KkcEngineClass * klass) {
	kkc_engine_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (KkcEnginePrivate));
	((IBusEngineClass *) klass)->process_key_event = (gboolean (*) (IBusEngine *, guint, guint, guint)) kkc_engine_real_process_key_event;
	((IBusEngineClass *) klass)->enable = (void (*) (IBusEngine *)) kkc_engine_real_enable;
	((IBusEngineClass *) klass)->disable = (void (*) (IBusEngine *)) kkc_engine_real_disable;
	((IBusEngineClass *) klass)->reset = (void (*) (IBusEngine *)) kkc_engine_real_reset;
	((IBusEngineClass *) klass)->focus_in = (void (*) (IBusEngine *)) kkc_engine_real_focus_in;
	((IBusEngineClass *) klass)->focus_out = (void (*) (IBusEngine *)) kkc_engine_real_focus_out;
	((IBusEngineClass *) klass)->property_activate = (void (*) (IBusEngine *, const gchar*, guint)) kkc_engine_real_property_activate;
	((IBusEngineClass *) klass)->candidate_clicked = (void (*) (IBusEngine *, guint, guint, guint)) kkc_engine_real_candidate_clicked;
	((IBusEngineClass *) klass)->cursor_up = (void (*) (IBusEngine *)) kkc_engine_real_cursor_up;
	((IBusEngineClass *) klass)->cursor_down = (void (*) (IBusEngine *)) kkc_engine_real_cursor_down;
	((IBusEngineClass *) klass)->page_up = (void (*) (IBusEngine *)) kkc_engine_real_page_up;
	((IBusEngineClass *) klass)->page_down = (void (*) (IBusEngine *)) kkc_engine_real_page_down;
	((IBusEngineClass *) klass)->set_content_type = (void (*) (IBusEngine *, guint, guint)) kkc_engine_real_set_content_type;
	G_OBJECT_CLASS (klass)->constructor = kkc_engine_constructor;
	G_OBJECT_CLASS (klass)->finalize = kkc_engine_finalize;
}


static void kkc_engine_instance_init (KkcEngine * self) {
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	self->priv = KKC_ENGINE_GET_PRIVATE (self);
	self->priv->properties_registered = FALSE;
	_tmp0_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, IBUS_TYPE_PROPERTY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->input_mode_props = (GeeMap*) _tmp0_;
	_tmp1_ = gee_hash_map_new (KKC_TYPE_INPUT_MODE, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->input_mode_symbols = (GeeMap*) _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, KKC_TYPE_INPUT_MODE, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->name_input_modes = (GeeMap*) _tmp2_;
	self->priv->save_dictionaries_timeout_id = (guint) 0;
}


static void kkc_engine_finalize (GObject * obj) {
	KkcEngine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KKC_ENGINE, KkcEngine);
	_g_object_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->lookup_table);
	_g_object_unref0 (self->priv->keymap);
	_g_object_unref0 (self->priv->input_mode_prop);
	_g_object_unref0 (self->priv->prop_list);
	_g_object_unref0 (self->priv->input_mode_props);
	_g_object_unref0 (self->priv->input_mode_symbols);
	_g_object_unref0 (self->priv->name_input_modes);
	_g_object_unref0 (self->priv->clipboard);
	G_OBJECT_CLASS (kkc_engine_parent_class)->finalize (obj);
}


GType kkc_engine_get_type (void) {
	static volatile gsize kkc_engine_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcEngine), 0, (GInstanceInitFunc) kkc_engine_instance_init, NULL };
		GType kkc_engine_type_id;
		kkc_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "KkcEngine", &g_define_type_info, 0);
		g_once_init_leave (&kkc_engine_type_id__volatile, kkc_engine_type_id);
	}
	return kkc_engine_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



